<script setup lang="ts">
import { ref} from 'vue';

import { type Product } from '@/types/Product'

import Dialog from '@/components/POSComponent/DialogItemDetail.vue'
import ProductList from '@/components/POSComponent/ProductList.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue';
import MemberCard from './MemberCard.vue';
import ReceiptCard from './ReceiptCard.vue';
import POSBtn from './POSBtn.vue';

import { useProductStore } from '@/stores/product';
import { useReceiptStore } from '@/stores/receipt';
import { nextTick } from 'vue';
import { provide } from 'vue';
import type { ReceiptItem } from '@/types/ReceiptItem';


const tab = ref(1)
const receiptStore = useReceiptStore()
const productStore = useProductStore()
const divReceiptItems = ref<HTMLElement | null>(null)
const dialog = ref(false)
provide('dialogItemDetail',dialog)
const initilProduct: Product = {
    id: 0,
    name: 'rose',
    price: 0,
    category: 'Drink',
    type: 'H',
    gsize: 'S',
    sweet_level: '100%',
    image: ''
}
const editedProduct = ref<Product>(JSON.parse(JSON.stringify(initilProduct)))
provide('editedProduct',editedProduct)
function closeDialog(){
        dialog.value = false
        nextTick(() => {
          editedProduct.value = Object.assign({}, initilProduct)
        })
}
provide('closeDialog',closeDialog)
function openDialog(p:Product){
    dialog.value = !dialog.value
    editedProduct.value.id = p.id
    editedProduct.value.name = p.name
    editedProduct.value.price = p.price
    editedProduct.value.type = productStore.editedProduct.type.charAt(0)
}
let indexf = ref(-1)
const  editedReceipt = ref<ReceiptItem>({
          id:-1,
          name:'',
          type:'-',
          gsize:'l',
          sweet_level:'-',
          price:0,
          unit:1,
          productId:0,
          product:initilProduct
      })
function openDialogEdit(r:ReceiptItem,index:number){
    dialog.value = !dialog.value
    indexf.value= index
    editedReceipt.value = r
    editedProduct.value.name = r.name
    editedProduct.value.type = r.type
    editedProduct.value.sweet_level = r.sweet_level
    editedProduct.value.gsize = r.gsize
}
const selected = (p:Product) => {
    if(indexf.value==-1){
        receiptStore.addReceiptItem(p)
    }else{
        receiptStore.editReceiptItem(editedProduct.value,editedReceipt.value,indexf.value)
        indexf.value = -1
    }
    
    closeDialog()
    nextTick(() => {
        if(divReceiptItems.value) divReceiptItems.value.scrollTo(0,divReceiptItems.value.scrollHeight)
    })
}
provide('selected',selected)
provide('openDialogEdit',openDialogEdit)
productStore.getProductCategory()
</script>
<template>
    <v-containner> 
        <v-row style="background-color: #E7D0B9;" >
            <v-col cols="12" md="5" style="padding-top: 45px;" >
                <v-sheet min-width="300" max-width="800" height="600" elevation="0" style="border: 2px solid black;background-color: #E7D0B9;">
                    <v-tabs v-model="tab" align-tabs="center">
                        <v-tab style="padding-right: 20px; padding-right: 20px;" :value="1" prepend-icon="mdi-coffee">Drink</v-tab>
                        <v-tab style="padding-right: 20px; padding-right: 20px;" :value="2" prepend-icon="mdi-cupcake">Dessert</v-tab>
                        <v-tab style="padding-right: 20px; padding-right: 20px;" :value="3" prepend-icon="mdi-baguette">Bakery</v-tab>
                    </v-tabs>
                    <v-window v-model="tab" >
                        <v-window-item :value="1" >
                            <ProductList :products="productStore.products1" @selectedProduct="openDialog"></ProductList>
                        </v-window-item>
                        <v-window-item :value="2">
                            <ProductList :products="productStore.products2" @selectedProduct="selected"></ProductList>
                        </v-window-item>
                        <v-window-item :value="3">
                            <ProductList :products="productStore.products3" @selectedProduct="selected"></ProductList>
                        </v-window-item>
                    </v-window>
                </v-sheet>
            </v-col>
            <v-col cols="12" md="7">
                <v-container style="padding: 0;">
                    <v-row>
                        <v-col cols="12" style="padding:5px;padding-top: 20px;"> 
                            <div ref="divReceiptItems" style="height: 279;overflow: auto; ">
                                <v-sheet min-width="300" max-width="820" height="279" elevation="6" style=" border: 2px solid black; background-color: #FFF8F1;">
                                    <div style="height: 279;"><ReceiptDetailTable></ReceiptDetailTable> </div>       
                                       
                                </v-sheet>
                            </div>
                            
                        </v-col>
                        <v-col cols="12" style="padding: 5px;">
                            <v-sheet min-width="300" max-width="820" height="80" elevation="6" style="border: 2px solid black;background-color: #FFF8F1;">
                              <MemberCard></MemberCard>
                            </v-sheet>
                        </v-col>
                        <v-col cols="12" style="padding: 5px;">
                            <v-sheet min-width="300" max-width="820" height="170" elevation="6" style="border: 2px solid black;background-color: #FFF8F1;">
                              <ReceiptCard></ReceiptCard>
                            </v-sheet>
                        </v-col>
                        <v-col cols="12" style="padding: 5px;">
                            <v-sheet min-width="300" max-width="820" height="80" elevation="6" style="border: 2px solid black;background-color: #FFF8F1;">
                              <POSBtn></POSBtn>
                            </v-sheet>
                        </v-col>
                    </v-row>
                </v-container>
            </v-col>
        </v-row>
        <Dialog></Dialog>
    </v-containner>
</template>
<style scoped>
 .v-tabs .v-tab {
    background-color: rgb(201, 136, 96); /* สีของ tab ที่ไม่ได้ถูกเลือก */
    color: black; /* สีของข้อความของ tab ที่ไม่ได้ถูกเลือก */
  }

  .v-tabs .v-tab:hover {
    background-color: rgb(155, 107, 67)!important; /* สีของ tab เมื่อ hover */
  }

  .v-tab:active {
    background-color: rgb(155, 107, 67)!important; /* สีของ tab ที่ถูกเลือก */
    color: black !important; /* สีของข้อความของ tab ที่ถูกเลือก */
  }

</style>